;;;
;;;  PO  Symbol class
;;;

($ap 1 "Symbol class")

;;;
;;; ֐ (SYMBOLP obj) --> boolean
;;;
($ap 2 "symbolp" P.63)
((symbolp 'a) t)
((symbolp "a") nil)
((symbolp #\a) nil)
((symbolp 't) t)
((symbolp t) t)
((symbolp 'nil) t)
((symbolp nil) t)
((symbolp '()) t)
((symbolp '*pi*) t)
((symbolp *pi*) nil)
;;;
($argc symbolp 1 0 0)
($predicate symbolp $symbol $t $null)

;;;
;;; ֐ (PROPERTY symbol property-name [obj]) --> <object>
;;;
($ap 2 "property" P.65)
;;;
($argc property 2 1 0)
($type property ($symbol $null) :target (quote abc))
($type property ($symbol $null) (quote abc) :target)
;;;
((property 'aaa 'bbb) nil)
((property 'aaa 'bbb 'zzz) zzz)

;;;
;;; ֐ (SET-PROPERTY obj symbol property-name) --> <object>
;;;
($ap 2 "set-property" P.66)
((setf (property 'zeus 'daughter) 'athena) athena)
((set-property 'athena 'zeus 'daughter) athena)
((property 'zeus 'daughter) athena)
;;;
($argc set-property 3 0 0)
($type set-property ($symbol $null) (quote a) :target (quote abc))
($type set-property ($symbol $null) (quote a) (quote abc) :target)
;;;
((list (setf (property 'aaa 'bbb) 'ccc) (property 'aaa 'bbb 'zzz)) 
 (ccc ccc) equal)
((list (set-property 'ccc 'aaa 'bbb) (property 'aaa 'bbb 'zzz)) 
 (ccc ccc) equal)

;;;
;;; ֐ (REMOVE-PROPERTY symbol property-name) --> <object>
;;;
($ap 2 "remove-property" P.66)
((remove-property 'zeus 'daughter) athena)
;;;
($argc remove-property 2 0 0)
($type remove-property ($symbol $null) :target (quote abc))
($type remove-property ($symbol $null) (quote abc) :target)
;;;
((list (remove-property 'aaa 'bbb) (property 'aaa 'bbb 'zzz)) 
 (ccc zzz) equal)

;;;
;;; ֐ (GENSYM) --> <symbol>
;;;
($ap 2 "gensym" P.66)
($eval (defmacro twice (x)
         (let ((v (gensym)))
           `(let ((,v ,x)) (+ ,v ,v)))))
((twice 5) 10 eql)
;;;
($argc gensym 0 0 0)
;;;
((symbolp (gensym)) t)
